#ifndef soltypes_xp_h
#define soltypes_xp_h

//
// Event command types
// 
const int CMD_TIMER = 0x11;
const int CMD_UNKNOWN_10 = 0x10;
const int CMD_PAINT = 0x07;
const int CMD_LEFT_BUTTON_DOWN = 0x03;
const int CMD_LEFT_BUTTON_UP = 0x04;
const int CMD_DRAG = 0x05;
const int CMD_DOUBLE_CLICK = 0x06;
const int CMD_RESET = 0x08;
const int CMD_MOVE_CARDS = 0x0a;
const int CMD_UPDATE_SCORE = 0x0f;
const int CMD_MOVE_CARDS_2 = 0x0e;
const int CMD_REVEAL_CARD = 0x0b;
const int CMD_KEYPRESS = 0x02;

struct global_data_t;
struct stack_t;
typedef DWORD(__stdcall*handle_stuff_t)(global_data_t*,DWORD,DWORD,DWORD);
typedef void(__stdcall*init_func_t)();

#pragma pack(1)
struct global_data_t
{
    handle_stuff_t func;
    DWORD unknown_04;
    char unknown_08[12];
    DWORD clicked_card;
    char unknown_18[24];
    DWORD score; // offset 0x30
    DWORD time;
    char unknown_38[32];
    DWORD from_move_index; // offset 0x58
    DWORD to_move_index; // offset 0x5c
    char unknown_60[12];
    stack_t* stacks[13];
};

struct card_t
{
    DWORD type; // bit 15 is visible-flag
    DWORD unknown_4;
    DWORD unknown_8;
};

struct move_info_t
{
    DWORD pos;
    DWORD num;
};

struct stack_t
{
    char unknown_00[24];
    move_info_t* move_info;
    DWORD size;
    DWORD max_size;
    card_t cards[52]; 
};

#endif
